/*
* MisterPOS
* @copyright 	Copyright (c) 2007-2014, Marco Moser
* @author       Marco Moser <marco.moser@webtonic.it>
* @version 	1/8/7 init
* @version 	27/3/14 update
*/

////////////////////////////////////////////////////////////////////////////////
// event handlers

function onArea(area_key)
{
    try
    {
	// spegne modificatori
	for(var mk in glob_moditem_map)
	{
	    gn("butmod"+mk).style.display='none';
	}
	// accende reparto
	for(var key in glob_areaitem_map)
	{
	    if (key==area_key) gn('artsbox'+key).style.display='';
	    else gn('artsbox'+key).style.display='none';
	}
	// spegne tavoli
	gn('seatsbox').style.display='none';
	gn('modop').style.display='none';

	//reset mdg daymenu
	if (mdg_last_ak)
	{
	    gn("mdgbox"+mdg_last_ak).style.display="none";
	    mdg_last_ak=null;
	    mdg_label=null;
	}

    }
    catch(exc)
    {
	alert('Exc='+exc);
    }
    window.location.href='#top_page';
}
function onArticle(ak,area_key)
{
    // varianti
    for(var mk in glob_moditem_map)
    {
	if (glob_moditem_map[mk].art_area==area_key) $("#butmod"+mk).show();
	else $("#butmod"+mk).hide();
    }

    glob_ticket_queue.add_art(1,ak,mdg_label);

    // daymenu
    if (glob_artitem_map[ak]['daymenu_keys'])
    {
    	if (glob_artitem_map[ak]['art_type']==70)
    	{
    	    // mostra composizione
    	    onComposite(ak,area_key); // ovvero ArticleBean.ART_TYPE_COMPOSITE=70
    	}
    	else // ART_TYPE_NORMAL=10 -> aggiunge tutti gli articoli
    	{
    	    var alist=glob_artitem_map[ak]['daymenu_keys'].split(/,/);
    	    for(var ii=0;ii<alist.length;ii++) glob_ticket_queue.add_art(1,alist[ii],mdg_label);
    	}
    }

}
function onTicketModifier(idx,ak)
{
    glob_ticket_queue.last_idx=idx; //dirty
    var area_key=glob_artitem_map[ak]['art_area'];
    for(var mk in glob_moditem_map)
    {
	if (glob_moditem_map[mk].art_area==area_key) $("#butmod"+mk).show();
	else $("#butmod"+mk).hide();
    }
    on_off_mod_box();
}





var mdg_nr=1;
var mdg_label=null;
var mdg_last_ak=null;
function onComposite(ak,area_key)
{
    mdg_last_ak=ak;
    mdg_nr+=1;
    mdg_label=""+glob_artitem_map[ak]['desc']+" "+ArticleBean_MDG_PREFIX+mdg_nr; // menu unico mdg1
    gn("mdgbox"+ak).style.display="";
    gn('artsbox'+area_key).style.display='none';
}
// + o -
function onMod_Op_toggle(btn_node,val_nodeid,val_1,val_2)
{
    var val=$('#'+val_nodeid).val();
    if (val==val_1)
    {
    	$('#'+val_nodeid).val(val_2);
    	$(btn_node).html(''+val_1+' / ('+val_2+')').addClass('pressed');
    }
    else
    {
    	$('#'+val_nodeid).val(val_1);
    	$(btn_node).html('('+val_1+') / '+val_2+'').removeClass('pressed');

    }
}
function onModClose(btn_node)
{
    $('#mod_box').hide();
}
function onModifier(mk)
{
    glob_ticket_queue.apply_modifier(mk,$('#butmod_op_1Q').val(),$('#butmod_op_sign').val());
    $('#mod_box').hide();
}
function onTavoli()
{
    //onArea(-1);
    gn("seatsbox").style.display="";
}
function onSeat(seat_key,seat_desc)
{
    glob_ticket_queue.tk_data.opt["seat"]=seat_key;
    glob_ticket_queue.tk_data.opt["seatdesc"]=seat_desc;
    glob_ticket_queue.refresh();
}

function onSeat_new()
{
    var seat_name=prompt('Nome tavolo');
    if (seat_name)
    {
	$.ajax({
	    type: 'POST',
	    url: 'seat_create_ajax.jssp',
	    data: { seat_name: seat_name },
	    success: function(data)
	    {
		if (data['errmsg']) alert(data['errmsg']);
		else window.location.href='ecam.jssp?jsonmsg='+encodeURIComponent(JSON.stringify(data));
	    },
	    dataType: 'json'
	}).fail(function() { alert('Errore di comunicazione con il server, riprova') });
    }
}


function onEcamPost(dosubmit,ticket_stus,ecam_tavolo_must_yes)
{
    if (ecam_tavolo_must_yes=='Y')
    {
	if (!glob_ticket_queue.tk_data.opt["seat"]) { alert('Seleziona il tavolo'); onTavoli(); return; }
    }
    glob_ticket_queue.tk_data.opt["ticket_stus"]=ticket_stus;
    glob_ticket_queue.tk_data.opt["ticketnote"]=gn("ticketnote").value;

    $('#div_loading').show();

    // ajax: evita di perdere l'ordine se il wifi e' fuori portata, la stampante non funziona, i piatti sono finiti
    $.ajax({
	type: 'POST',
	url: 'post_ticket_ajax.jssp',
	data: { ticketpost: JSON.stringify(glob_ticket_queue.tk_data) },
	success: function(data)
	{
	    if (data['errmsg']) alert(data['errmsg']);
	    else window.location.href='ecam.jssp?jsonmsg='+encodeURIComponent(JSON.stringify(data));
	    $('#div_loading').hide();
	},
	dataType: 'json'
    }).fail(function() { $('#div_loading').hide(); alert('Errore di comunicazione con il server, riprova'); });
}


function onButOp()
{
    onArea(-1); // collassa tutto
    gn("modop").style.display="";
    window.location.href='#mod_page';
}

function listacomande_click(list_type)
{
    if (list_type==11) window.location.href="ticket_list.jssp?filter_waiterkey="+getCCookie('mywaiterkey'); // my
    else if (list_type==33) window.location.href="ticket_list.jssp?filter_seatkey=-2"; // parcheggiati
    else if (glob_ticket_queue.tk_data.opt["seat"]) window.location.href="ticket_list.jssp?filter_seatkey="+glob_ticket_queue.tk_data.opt["seat"];
    else window.location.href="ticket_list.jssp?filter_seatkey=-1"; // if (list_type==22) // all
}



////////////////////////////////////////////////////////////////////////////////
// helper



function Ticket_Queue()
{
    this.tk_data=new TicketData();
    this.last_idx=0;

    this.add_art = function(qt,ak,mdg_label)
    {
    	if (!glob_artitem_map[ak])
    	{
    	    alert('Articolo '+ak+' non disponibile'); // qt<0
    	    return;
    	}
	for(var ii=0;ii<this.tk_data.items.length;ii++)
	{
	    if (this.tk_data.items[ii].ak==ak && !this.tk_data.items[ii].mdesc)
	    {
		qt+=this.tk_data.items[ii].qt;
		this.tk_data.items.splice(ii,1);
		break;
	    }
	}
	var ec=glob_artitem_map[ak]['ec'];
	var mdesc=null;
	if (mdg_label)
	{
	    mdesc=mdg_label;
	    if (!glob_artitem_map[ak]['daymenu_keys']) ec=0; // lascia il menu con prezzo, gli item prezzo 0
	}

	this.tk_data.items.unshift(new TicketItem(qt,ak,glob_artitem_map[ak].desc,mdesc,ec,glob_artitem_map[ak].discounter));
	this.refresh(0);
    }

    this.set_item_qt=function(idx,qt)
    {
    	if (qt==0) { this.tk_data.items.splice(idx,1); this.refresh(-1); }
    	else { this.tk_data.items[idx].qt=qt; this.refresh(idx); }
    }


    /**
    * @param mod_key [123] key
    * @param butmod_op_1Q [1] singola qt [Q] applica su tutto
    * @param butmod_op_sign [+] +variante con prezzo [-] -variante senza prezzo
    */
    this.apply_modifier = function(mod_key,butmod_op_1Q,butmod_op_sign)
    {
    	if (this.last_idx<0 || this.last_idx>=this.tk_data.items.length) this.last_idx=0;
	var cur_titem=this.tk_data.items[this.last_idx];
	if (!cur_titem) return;
	if (butmod_op_1Q==1 && cur_titem.qt>1)
	{
	    this.dec_item_qt(this.last_idx); // -1
	    this.tk_data.items.unshift(new TicketItem(1,cur_titem.ak,cur_titem.adesc,cur_titem.mdesc,cur_titem.ec,cur_titem.discounter));
	    this.last_idx=0;
	    cur_titem=this.tk_data.items[this.last_idx];
	}

	var mdesc=cur_titem.mdesc;
	if (!mdesc) mdesc='';
	var ec_price=0;
	if (butmod_op_sign=='-')
	{
	    mdesc+=' -'+glob_moditem_map[mod_key].desc;
	    //senza prezzo
	}
	else
	{
	    mdesc=mdesc+=' +'+glob_moditem_map[mod_key].desc;
	    ec_price=glob_moditem_map[mod_key].ec;
	}
	if (glob_moditem_map[mod_key].discounter) //ART_TYPE_FREEMODIFIER=sconto secco (omaggio)
	    this.tk_data.items[this.last_idx]=new TicketItem(cur_titem.qt,cur_titem.ak,cur_titem.adesc,mdesc,ec_price,cur_titem.discounter);
	else // ART_TYPE_MODIFIER||ART_TYPE_CONSEGNADOPO
	    this.tk_data.items[this.last_idx]=new TicketItem(cur_titem.qt,cur_titem.ak,cur_titem.adesc,mdesc,cur_titem.ec+ec_price,cur_titem.discounter);
	this.refresh(this.last_idx);
    }



    this.inc_item_qt = function(idx)
    {
	this.tk_data.items[idx].qt+=1;
	this.refresh(idx);
    }
    this.dec_item_qt = function(idx)
    {
	if (this.tk_data.items[idx].qt>1) { this.tk_data.items[idx].qt-=1; this.refresh(idx); }
	else { this.tk_data.items.splice(idx,1); this.refresh(-1); }
    }
    // evidenzia hi_idx (maybe null)
    this.refresh = function(hi_idx)
    {
    	var htmlbuf='<div class="ticket_summary">';
	var sum_euro=0;
	var sum_qt=0;
	var hasdiscounter=false;
	var sub_map={};
	this.last_idx=hi_idx;
	for(var ii=0;ii<this.tk_data.items.length;ii++)
	{
	    htmlbuf+=this.prepare_item(this.tk_data.items[ii],ii,ii==hi_idx);

	    if (this.tk_data.items[ii].discounter) hasdiscounter=true;
	    if (hasdiscounter) sum_euro=0;
	    else sum_euro+=this.tk_data.items[ii].qt*this.tk_data.items[ii].ec;

	    var my_area=glob_artitem_map[this.tk_data.items[ii].ak]['art_area'];
	    if (!sub_map[my_area]) sub_map[my_area]=0;
	    sub_map[my_area]+=this.tk_data.items[ii].qt;

	    sum_qt+=this.tk_data.items[ii].qt;
	}

	// totalone
	htmlbuf+='<div class="ticket_tot" style="text-align: center; font-weight: bold;">';
	htmlbuf+='TOTALE '+glob_party_currency+' '+eur(sum_euro);
	htmlbuf+='</div>'; //ticket_tot

	// riassunto reparti
	var sub_list=[];
	for(var my_area in sub_map)
	{
	    sub_list.push(''+sub_map[my_area]+' '+glob_areaitem_map[my_area]['rdesc']);
	}
	var sub_desc='';
	if (sub_list) sub_desc+='<span style="text-transform: lowercase;">'+sub_list.join(', ')+'</span>';
	if (this.tk_data.opt["seatdesc"]!=undefined) sub_desc+=' <span style="text-transform: uppercase;">('+this.tk_data.opt["seatdesc"]+')</span>';
	if (sub_desc) htmlbuf+='<div style="font-size: 80%; text-align: center;">'+sub_desc+'</div>';

	htmlbuf+='</div>'; //ticket_summary
	ticket_data_update(htmlbuf,sum_qt);
    }

    this.prepare_item = function(ticket_item,idx,w_high)
    {
    	var wb='';

	if (w_high) wb+='<div class="ticket_item ticket_hi">';
	else wb+='<div class="ticket_item">';

	var adesc=htmlspecialchars(ticket_item.adesc+" "+(ticket_item.mdesc||''));

    	wb+='<select class="select_qt" onchange="changing_item_qt(this,'+idx+')">';
    	var min=-3+ticket_item.qt;
    	if (min<1) min=1;
    	max=min+7;
    	wb+='<option value="0">0</option>';
    	for(var qt=min;qt<max;qt++)
    	{
    	    if (qt==ticket_item.qt)
		wb+='<option value="'+qt+'" selected="selected">'+qt+'</option>';
	    else
	    	wb+='<option value="'+qt+'">'+qt+'</option>';
    	}
    	wb+='<option value="P">..</option>';
    	wb+='</select>';
    	wb+='<a class="a_desc" href="javascript:void(onTicketModifier('+idx+','+ticket_item.ak+'))">'+adesc+'<div class="ticket_price">x '+eur(ticket_item.ec)+'</div></a>'; // cambia desc
    	wb+='<a class="a_inc" href="javascript:void(changing_addqt('+idx+'))" >+</a>';
    	wb+='<a class="a_dec" href="javascript:void(changing_zeroqt('+idx+'))" >-</a>';
    	wb+='<br/>';



    	wb+='</div>';
    	return wb;
    }



    // function(qt,ak,mdg_label)
    this.load_list = function(reticket_map)
    {

    	var ticket_item_list=reticket_map['ticket_item_list'];
	for(var ii=0;ii<ticket_item_list.length;ii++)
	{
	    this.tk_data.items.unshift(new TicketItem(
	    	ticket_item_list[ii]['item_qt'],
	    	ticket_item_list[ii]['item_art'],
	    	ticket_item_list[ii]['item_artdesc'],
	    	ticket_item_list[ii]['modifier_desc'],
	    	ticket_item_list[ii]['sold_price'],
	    	ticket_item_list[ii]['item_discount']
	    	));
	}
	this.refresh(0);
    }
}



function changing_item_qt(select_node,idx)
{
    var qt=select_node.options[select_node.selectedIndex].value;
    if (qt=='P')
    {
    	qt=prompt('Qt','');
    	if (qt==null) return;
    }
    qt=parseInt(qt);
    glob_ticket_queue.set_item_qt(idx,qt);
}
function changing_addqt(idx)
{
    glob_ticket_queue.inc_item_qt(idx);
}
function changing_zeroqt(idx)
{
    glob_ticket_queue.dec_item_qt(idx);
}


////////////////////////////////////////////////////////////////////////////////
// functions



function ticket_data_update(tick_html,tick_qt)
{
    $("#ticketlog").html(tick_html);
    $("#span_cart").html(''+tick_qt+'').hide().fadeIn('slow');
}





function richiama_ticket_per_modifica(deledit_ticketkey)
{
    $.ajax({
	type: 'GET',
	url: 'ticket_deledit_ajax.jssp',
	data: { deledit_ticketkey: deledit_ticketkey },
	success: function(data)
	{
	    if (data['errmsg']) alert(data['errmsg']);
	    else glob_ticket_queue.load_list(data['reticket_map']);
	},
	dataType: 'json'
    }).fail(function() { alert('Errore di comunicazione con il server, riprova') });
}




