/*
* Project Jabir 2 www.misterpos.it
* @copyright 	Copyright (c) 2007 Marco Moser
* @author       Marco Moser <marco@marcomoser.it>
* @version 	01/08/2007 init
*/

// get node by id
function gn(id)
{
    return document.getElementById(id);
}

function eur(ec)
{
    ec=parseInt(ec);
    if (isNaN(ec) || !ec) return '0,00';

    var sym='';
    if (ec<0) { ec=-ec; sym='-'; }
    var cents=parseInt(ec%100);
    ec=parseInt(ec/100);
    return ''+sym+ec+','+((cents<10)?'0'+cents:cents);
}
function selectDefault(selem,value)
{
    for(var ii=0;ii<selem.options.length;ii++)
    {
	if (selem.options[ii].value==value)
	{
	    selem.options[ii].selected=true;
	    break;
	}
    }
}
function getPrnhostname()
{
    var mm = document.cookie.match(/\bprnhostname=([^;]+)/);
    return (mm && mm[1])||null;
}
function setPrnhostname(prnhostname)
{
    document.cookie="prnhostname="+prnhostname+"; path=/;";
}

function nowSS()
{
    var yyy=new java.text.SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
    return yyy.format(new java.util.Date());
}

function date2df(jdate)
{
    var yyy=new java.text.SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
    return yyy.format(jdate);
}


function date2day(jdate)
{
    var yyy=new java.text.SimpleDateFormat("EEE dd/MM HH:mm");
    return yyy.format(jdate);
}

function date2hhmm(jdate)
{
    var yyy=new java.text.SimpleDateFormat("HH:mm");
    return yyy.format(jdate);
}

// client html
function setCCookie(name,value)
{
    document.cookie=name+"="+value+"; path=/;";
}
// client html
function getCCookie(name)
{
    var re = new RegExp('\\b'+name+'=([^;]+)');
    var mm = re.exec(document.cookie);
    return (mm && mm[1])||null;
}
// server js: todo request.getCookie_by_name
function getSCookie(request,name)
{
    var cookie=request.getHeader("cookie");
    var re = new RegExp('\\b'+name+'=([^;]+)');
    var mm = re.exec(cookie);
    return (mm && mm[1])||null;
}

// check if value is !null e valid (anticrack)
function isvl(value)
{
    if (!value || value=="") return false;
    return true;
}
function isnvl(value)
{
    if (!value || value==false || value=="" || value==0) return true;
    return false;
}
function nvl2(value,alt)
{
    return isnvl(value)?alt:value;
}

function nvl3(label,value,alt)
{
    if (!value || value==false || value=="" || value==0) return alt;
    return label+value;
}
// parseInt
function myint(value)
{
    value=Math.round(value); //todo prova bit|0
    if (isNaN(value)) value=0;
    return ''+value;
}

function vdump(xx)
{
    var ret='';
    for(var it in xx) { ret+=''+it+'='+xx[it]+'=\n'; }
    return ret;
}

// da java a script
function js_str(str)
{
    if (str==null) return '';
    return ''+str;
}
function js_int(nr)
{
    if (nr==null) return 0;
    return parseInt(nr,10);
}
// da script a output
function so_int(nr)
{
    nr=Math.round(nr);
    if (isNaN(nr)) return '0';
    return ''+nr;
}

function htmlspecialchars(str)
{
  return str
      .replace(/&/g, "&amp;")
      .replace(/</g, "&lt;")
      .replace(/>/g, "&gt;")
      .replace(/"/g, "&quot;")
      .replace(/'/g, "&#039;");
}



